/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: Report.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.share;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.Immutable;
import java.util.ArrayList;
import java.util.List;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
@Immutable
public class Report
  {
    protected final List<String> recipients;
    protected final String subject;
    protected final String body;
    protected final String mimeType;

    public Report()
      {
        this(new ArrayList<String>(), "", "", "text/plain");
      }

    private Report (final @Nonnull List<String> recipients,
                    final @Nonnull String subject,
                    final @Nonnull String body,
                    final @Nonnull String mimeType)
      {
        this.recipients = recipients;
        this.subject = subject;
        this.body = body;
        this.mimeType = mimeType;
      }

    @Nonnull
    public List<String> getRecipients()
      {
        return recipients;
      }

    @Nonnull
    public Report withRecipients (final @Nonnull List<String> recipients)
      {
        return new Report(recipients, subject, body, mimeType);
      }

    @Nonnull
    public String getSubject()
      {
        return subject;
      }

    @Nonnull
    public Report withSubject (final @Nonnull String subject)
      {
        return new Report(recipients, subject, body, mimeType);
      }

    @Nonnull
    public String getBody()
      {
        return body;
      }

    @Nonnull
    public Report withBody (final @Nonnull String body)
      {
        return new Report(recipients, subject, body, mimeType);
      }

    @Nonnull
    public String getMimeType()
      {
        return mimeType;
      }

    @Nonnull
    public Report withMimeType (final @Nonnull String MimeType)
      {
        return new Report(recipients, subject, body, mimeType);
      }
  }
